
--Base API
print("Loading... API")
enable = true
disable = false
debug = enable
gfx = love.graphics
fsm = love.filesystem
wdw = love.window
tmr = love.timer
mse = love.mouse
kbd = love.keyboard
rand = love.math.random
tau = math.pi*2
width, height = love.graphics.getWidth(),love.graphics.getHeight()
smallF = gfx.newFont(12)
mediumF = gfx.newFont(16)
largeF = gfx.newFont(18)
Title = wdw.getTitle()
garbage_timer = 0
gfx.setDefaultFilter("nearest", "nearest")

print("Calculator")
require "calc"
print("Model Loader")
model = require "modelLoader"
print("Drawing Function")
require "3ddraw"
print("Camera")
require "camera"
print("Done")
print("..............................")

function standardUpdate(dt)
	mouseX, mouseY = mse.getPosition()
	garbage_timer = garbage_timer + dt
	if garbage_timer >= 30 then
		collectgarbage()
		print("Garbage Collection Successful")
		garbage_timer = 0
	end
	if debug then
		wdw.setTitle(Title.. " " ..tmr.getFPS())
		MemoryUsage = collectgarbage("count")
	end
end

function debugDraw()
	if debug then

	end
end

function setFont(name)
	gfx.setFont(assert(name, "Invalid Font"))
end

function apiFunctionKeys(key)
	if key == "f1" then
		gfx.setShader(effect)
	elseif key == "f2" then
		gfx.setShader()
	elseif key == "f4" then
		gfx.setWireFrame(not gfx.isWireFrame())
	elseif key == "f7" then
		debug = not debug
		wdw.setTitle(Title)
	elseif key == "f10" then
		collectgarbage()
	elseif key == "escape" then
		love.event.push("quit")
	end
end

--Mathematical Alogrithms--
function dist(x1, y1, x2, y2)
	return math.sqrt(((x2-x1)^2)+((y2-y1)^2))
end

function distV(v1, v2)
	return math.sqrt(((v2.x-v1.x)^2)+((v2.y-v1.y)^2))
end

function slope(x1, y1, x2, y2)
	return (y2 - y1)/(x2 - x1)
end

function clamp(val, low, up)
	if low > up then low, up = up, low end
	return math.max(low, math.min(val, up))
end

function ratio(a, b)
	return a/b
end

--Conversions

function Celsius(temp)
	return (temp - 32) * (5/9)
end

function Faren(temp)
	return (temp * (1.8)) + 32
end



--Logical Callbacks
function boxCollision(x1, y1, w1, h1, x2, y2, w2, h2)
	return y1 < y2 + h2 and y2 < y1 + h1 and x1 < x2 + w2 and x2 < x1 + w1
end

--Senseless Crap
