function translate(x, y, z)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          vertex.x = vertex.x + x
          vertex.y = vertex.y + y
          vertex.z = vertex.z + z
        end
      end
    end
  end
end

-----------------------------------------------------------------------
-- Rotation functions need to be implemented with rotation matricies --
-----------------------------------------------------------------------

function rotateX(angle)
  local sin, cos = math.sin(angle), math.cos(angle)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          local x, y, z = vertex.x, vertex.y, vertex.z

          vertex.y = x + y + z
          vertex.z = x + y + z
        end
      end
    end
  end
end

function rotateY(angle)
  local sin, cos = math.sin(angle), math.cos(angle)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          local x, y, z = vertex.x, vertex.y, vertex.z

          vertex.x = x + y + z
          vertex.z = x + y + z
        end
      end
    end
  end
end

function rotateZ(angle)
  local sin, cos = math.sin(angle), math.cos(angle)
  for i = 1, #objects do
    for _, object in pairs(objects[i]) do
      if _ == "vertecies" then
        for key, vertex in pairs(object) do
          local x, y, z = vertex.x, vertex.y, vertex.z

          vertex.x = x + y + z
          vertex.y = x + y + z
        end
      end
    end
  end
end

function Update_Camera(dt)
  if kbd.isDown("w") then
		translate(0, 0, dt)
  end
	if kbd.isDown("s") then
		translate(0, 0, -dt)
  end
	if kbd.isDown("a") then
		translate(dt, 0, 0)
  end
	if kbd.isDown("d") then
		translate(-dt, 0, 0)
	end
	if kbd.isDown("lshift") then
		translate(0, dt, 0)
	end
  if kbd.isDown("control") then
		translate(0, -dt, 0)
	end
  if kbd.isDown("e") then
		rotateY(dt)
	end
  if kbd.isDown("q") then
		rotateY(-dt)
	end
end
