function love.load(arg)
	if arg[#arg] == "-debug" then require("mobdebug").start() end
	require "api"

	effect = gfx.newShader("shader.glsl")

	UIsml = gfx.setNewFont("_bin/_fonts/segoeui.ttf", 14)
	UImed = gfx.setNewFont("_bin/_fonts/segoeui.ttf", 20)
	UIlrg = gfx.setNewFont("_bin/_fonts/segoeui.ttf", 30)

	models = model.loadModels()

	function addModel(model, amount)
		for i = 1, amount do
			objects[#objects + 1] = assert(models[model], "Invalid model or model name")
		end
	end

	objects = {}
	addModel("cube", 1)
end

function love.update(dt)
	standardUpdate(dt)

	Update_Camera(dt)
end

function love.draw()
	debugDraw()

	Draw()
end

function love.keypressed(key)
	apiFunctionKeys(key)
end

function love.keyreleased(key)

end

function love.textinput(input)

end

function love.mousepressed(x, y, button)

end

function love.mousereleased(x, y, button)

end

function love.focus(isFocused)

end

function love.visible(isVisible)

end

function love.resize(w, h)

end

function love.quit()

end






function love.run()

	if love.math then
		love.math.setRandomSeed(os.time())
	end

	if love.event then
		love.event.pump()
	end

	if love.load then love.load(arg) end

	-- We don't want the first frame's dt to include time taken by love.load.
	if love.timer then love.timer.step() end

	local dt = 0

	-- Main loop time.
	while true do
		if love.event then
			love.event.pump()
			for e,a,b,c,d in love.event.poll() do
				if e == "quit" then
					if not love.quit or not love.quit() then
						if love.audio then
							love.audio.stop()
						end
						return
					end
				end
				love.handlers[e](a,b,c,d)
			end
		end

		if love.timer then
			love.timer.step()
			dt = love.timer.getDelta()
		end

		if love.update then love.update(dt) end -- will pass 0 if love.timer is disabled

		if love.window and love.graphics and love.window.isCreated() then
			love.graphics.clear()
			love.graphics.origin()
			if love.draw then love.draw() end
			love.graphics.present()
		end

		if love.timer then love.timer.sleep(0.01) end
	end
end